﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Verse;
using RimWorld;
using UnityEngine;

namespace AIRyrtwofAddon.Information
{
    public class CompProperties_AbnosInfo : CompProperties
    {
        public string classID;
        public List<string> story;

        public List<string> exDesc;

        private List<Feature> features = null;

        public List<ImageDesc> exInfo = null;
        private float exInfoSize = -1f;

        private List<StringColor> tempFeatures;
        public List<StringColor> AllFeatures
        {
            get
            {
                if (tempFeatures.NullOrEmpty())
                {
                    tempFeatures = new List<StringColor>();
                    if (!features.NullOrEmpty())
                        tempFeatures.AddRange(
                            features.Select(x => InfoContentCache.features[(int)x])
                            );
                }
                return tempFeatures;
            }
        }

        private string elCap = null;

        public string ELCap
        {
            get {
                if (elCap == null)
                {
                    if (electricCapacity == null || electricCapacity == Vector2.zero)
                    {
                        elCap = "発電しません";
                        return elCap;
                    }

                    elCap = Math.Min(electricCapacity.x, electricCapacity.y).ToString();
                    if (electricCapacity.x != electricCapacity.y)
                    {
                        elCap += "~" + Math.Max(electricCapacity.x, electricCapacity.y).ToString();
                    }
                    elCap += "W";

                }
                return elCap;
            }
        }

        public bool isTool = false;

        public Vector2 electricCapacity;

        public Danger danger = Danger.ZAYIN;
        public ThingDef ego = null;


        public CompProperties_AbnosInfo()
        {
            compClass = typeof(CompAbnosInfo);

        }

        public float ExInfoSize(float width)
        {
            if (exInfoSize < 0) {
                exInfoSize = 0f;
                foreach (ImageDesc id in exInfo)
                {
                    exInfoSize += id.Height(width);
                }
            }
            return exInfoSize;
        }

    }



}
